
%option noyywrap

%{
// https://stackoverflow.com/questions/9611682/flexlexer-support-for-unicode/9617585#9617585
#include "parser.hpp"
#include "main.h"
%}

%x s

%%

"null" { return T_NULL; }
"true" { return T_TRUE; }
"false" { return T_FALSE; }
[+-]?[0-9]*(\.[0-9]+)? { token = (double)std::stod(yytext); return T_NUMBER; }

"\""         { BEGIN(s); token = std::string(); }
<s>\\n       { std::get<std::string>(token) += "\n"; }
<s>\\r       { std::get<std::string>(token) += "\r"; }
<s>\\t       { std::get<std::string>(token) += "\t"; }
<s>\\[\\"]   { std::get<std::string>(token) += yytext[1]; }
<s>[^\n"\\]* { std::get<std::string>(token) += yytext; }
<s>\"        { BEGIN(INITIAL);  return T_STRING; }

\[           { return T_LBRACKET; }
\]           { return T_RBRACKET; }
,            { return T_COMMA; }

[ \n\t]  ;
.       { return YYerror; }

%%
